/*
Copyright (C) 2001-2002 Tomas Jakobsson.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __GAME__
#define __GAME__

#include	"menu.h"

#define		NUM_ENGINE_FUNCS	8

void	PlayerPreThink (edict_t *ent);
void	PlayerPostThink (edict_t *ent);
void	BotDisconnect (edict_t *bot);
void	ClientConnect (edict_t *ent);
void	ClientDisconnect (edict_t *ent);
void	PutClientInServer (edict_t *ent);
void	PutObserverInServer (edict_t *ent);

typedef struct
{
	void	(*func)(void);
	char	*name;
} gamefuncs_t;

extern gamefuncs_t gamefuncs[NUM_ENGINE_FUNCS];

#define		MSG_BROADCAST		0
#define		MSG_ONE				1
#define		MSG_ALL				2
#define		MSG_INIT			3

void	WayPoint (void);
void	StartPoint (void);
void	FinishPoint (void);

void	CarTouch (void);
void	RestartTimer (void);
void	SUB_Null (void);
void	KickABot (void);
void	WorldSpawn (void);
void	BotInit (void);
void	RotateCar (void);
void	LapTrigger1 (void);
void	LapTrigger2 (void);
void	LapTrigger3 (void);
void	Precaches (void);
void	CalcYaw (edict_t *ent);
void	MoveBot (edict_t *ent);
void	BotConnect (edict_t *ent);
void	UpdateToAll (edict_t *ent);
void	ChangeAngles (edict_t *ent);
void	GetCarToMove (edict_t *ent);
void	ImpulseCommands (edict_t *ent);
void	PrecacheModel (char *model);
void	Setmodel (edict_t *ent, char *model);
void	Normalize (vec3_t value, vec3_t newvalue);
void	VectoAngles (vec3_t value, vec3_t newvalue);
void	SetMinMaxSize (edict_t *e, float *min, float *max);

float	VectoYaw (vec3_t value);
float	Min3 (float value1, float value2, float value3);

trace_t	Traceline (vec3_t v1, vec3_t v2, edict_t *ent);

edict_t	*Find (edict_t *edict, char *s);
edict_t	*Nextent (edict_t *edict);
edict_t	*Spawn (void);

sizebuf_t	*WriteDest (byte dest);

extern	list_t	p_cars[64];
extern	int		p_numcars;

#endif //__GAME__
