/*
Copyright (C) 2001-2002 Tomas Jakobsson.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"../quakedef.h"
#include	"../game.h"

void ClientConnect (edict_t *ent)
{
	int	i;

	ent->game.ClientNo = (NUM_FOR_EDICT (ent)) - 1;

	for (i=0; i<8; i++)
	{
		ent = EDICT_NUM (i+1);

		if (ent->game.Active)
			UpdateToAll (ent);
	}
}

void ClientDisconnect (edict_t *ent) 
{
	SV_BroadcastPrintf ("%s has left the game.\n", ent->game.netname);
	
	//_snprintf (ent->game.netname, sizeof(ent->game.netname), "");
	ent->game.classname = "";
	ent->game.Active	= false;
	ent->game.ClientNo 	= -1;
	ent->game.nextthink = sv.time;
	ent->game.think		= SUB_Null;
		
	Setmodel (ent, "");
}

void PlayerPreThink (edict_t *ent) 
{
	if (!ent->game.isbot)
		GetCarToMove (ent);
	else
// #warning FIXME: bot count error
//disable bots support
	{
	    if(!COM_CheckParm("-nobots"))
		    MoveBot (ent);
	}
}

void PlayerPostThink (edict_t *ent)
{
	if (ent->game.impulse && !ent->game.isbot)
	{
		ImpulseCommands (ent);
		ent->game.impulse = 0;
	}
}

void PutClientInServer (edict_t *ent) 
{
	vec3_t	min	= {-12,-12,-4};
	vec3_t	max	= { 12, 12, 4};

	VectorCopy (miniracer.startpoint[ent->game.ClientNo].origin, ent->game.origin);
	VectorCopy (miniracer.startpoint[ent->game.ClientNo].angles, ent->v.angles);

	ent->game.classname		= "client";
	ent->game.Active 		= true;
	ent->game.ways			= 0;
	ent->game.laps			= 0;
	ent->game.laptrigger	= 3;
	ent->game.fly			= false;
	ent->game.touch			= CarTouch;
	ent->game.isbot			= false;

	Setmodel 		(ent, va("models/%s", ent->v.model));
	SetMinMaxSize	(ent, min, max);
	SV_LinkEdict	(ent, false);

	SV_BroadcastPrintf ("%s entered the game.\n", ent->game.netname);
}

void PutObserverInServer (edict_t *ent) 
{
	VectorCopy (miniracer.startpoint[0].origin, ent->game.origin);
	VectorCopy (miniracer.startpoint[0].angles, ent->v.angles);

	SV_BroadcastPrintf ("%s entered the game.\n", ent->game.netname);
}
