/*
Copyright (C) 2002-2003 Martin Weiss.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"../quakedef.h"
#include	"../menu.h"


int LoadList (char *listfile, list_t *list, qboolean fatal)
{
	char			temp[64][32];
	int			list_count = 0, len=0, i, j;
	char			*fhandle;
	
	fhandle=(char *)COM_LoadHunkFile(listfile);
	if(!fhandle)
	{
	    if(fatal)
		Sys_Error("Could not open %s\n", listfile);
	    else
		Con_Printf("Could not open %s\n", listfile);
	}

	for(j=0;j<com_filesize;j++)
	{
	    temp[list_count][len]=fhandle[j];
	    len++;
	    if(fhandle[j]=='\n')
	    {
		temp[list_count][len-1]='\0';
		list_count++;
		len=0;
	    }
	}
	                            
	for (i=0; i<list_count; i++)
	{
		COM_StripExtension (temp[i], list[i].name);
		
		if (i == 64)
			return 64;
	}

	return list_count;
}
